library bv_utilities; use bv_utilities.bv_arithmetic.all;

entity mult_mant is

	generic(F_WIDTH: positive := 6);

	port(	faktor1_frac:	in	bit_vector(F_WIDTH-1 downto 0);
			faktor2_frac:	in	bit_vector(F_WIDTH-1 downto 0);
			produkt_mant:	out bit_vector(F_WIDTH+1 downto 0));

end entity mult_mant;


architecture structure1 of mult_mant is

	constant INT_MANT_WIDTH: positive := F_WIDTH + 2;

	type connection_array is array(INT_MANT_WIDTH-2 downto 0) of bit_vector(INT_MANT_WIDTH-1 downto 0);

	signal faktor1_mant:	bit_vector(INT_MANT_WIDTH-1 downto 0);
	signal faktor2_mant:	bit_vector(INT_MANT_WIDTH-1 downto 0);
	signal wire:			connection_array;
	signal null_vector : bit_vector(INT_MANT_WIDTH-1 downto 0) := (others => '0');  -- naja, ein bischen umstaendlich...

begin

	faktor1_mant(INT_MANT_WIDTH-1)				<= '0';
	faktor1_mant(INT_MANT_WIDTH-2)				<= '1';
	faktor1_mant(INT_MANT_WIDTH-3 downto 0)	<= faktor1_frac;
	
	faktor2_mant(INT_MANT_WIDTH-1)				<= '0';
	faktor2_mant(INT_MANT_WIDTH-2)				<= '1';
	faktor2_mant(INT_MANT_WIDTH-3 downto 0)	<= faktor2_frac;

	cond_add_chain: for n in 0 to INT_MANT_WIDTH-2 generate
	begin
		first: if n = 0 generate
		begin
			cond_add: entity work.cond_add
			generic map(INT_MANT_WIDTH)
			port map(x => null_vector,
						y => faktor1_mant,
						cond => faktor2_mant(n),
						z => wire(n));
		end generate first;
		follow: if n /= 0 generate
		begin
			cond_add: entity work.cond_add
			generic map(INT_MANT_WIDTH)
			port map(x => wire(n-1),
						y => faktor1_mant,
						cond => faktor2_mant(n),
						z => wire(n));
		end generate follow;
	end generate cond_add_chain;
	
	produkt_mant <= wire(INT_MANT_WIDTH-2);
		
end architecture structure1;
